Add list of design documents implemented in version 2.6
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34
35 # Note: these are automake-specific variables, and must be named after
36 # the directory + 'dir' suffix
37 clientdir = $(pkgpythondir)/client
38 hypervisordir = $(pkgpythondir)/hypervisor
39 httpdir = $(pkgpythondir)/http
40 masterddir = $(pkgpythondir)/masterd
41 confddir = $(pkgpythondir)/confd
42 rapidir = $(pkgpythondir)/rapi
43 serverdir = $(pkgpythondir)/server
44 watcherdir = $(pkgpythondir)/watcher
45 impexpddir = $(pkgpythondir)/impexpd
46 utilsdir = $(pkgpythondir)/utils
47 toolsdir = $(pkglibdir)/tools
48 iallocatorsdir = $(pkglibdir)/iallocators
49 pytoolsdir = $(pkgpythondir)/tools
50 docdir = $(datadir)/doc/$(PACKAGE)
51 myexeclibdir = $(pkglibdir)
52
53 # Delete output file if an error occurred while building it
54 .DELETE_ON_ERROR:
55
56 HTOOLS_DIRS = \
57         htools \
58         htools/Ganeti \
59         htools/Ganeti/Confd \
60         htools/Ganeti/HTools \
61         htools/Ganeti/HTools/Program
62
63 DIRS = \
64         autotools \
65         daemons \
66         devel \
67         doc \
68         doc/examples \
69         doc/examples/hooks \
70         doc/examples/gnt-debug \
71         $(HTOOLS_DIRS) \
72         lib \
73         lib/client \
74         lib/build \
75         lib/confd \
76         lib/http \
77         lib/hypervisor \
78         lib/impexpd \
79         lib/masterd \
80         lib/rapi \
81         lib/server \
82         lib/tools \
83         lib/utils \
84         lib/watcher \
85         man \
86         qa \
87         test \
88         test/data \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/data/ovfdata \
92         test/data/ovfdata/other \
93         tools
94
95 BUILDTIME_DIR_AUTOCREATE = \
96         scripts \
97         $(APIDOC_DIR) \
98         $(APIDOC_PY_DIR) \
99         $(APIDOC_HS_DIR) \
100         $(APIDOC_HS_DIR)/Ganeti \
101         $(APIDOC_HS_DIR)/Ganeti/Confd \
102         $(APIDOC_HS_DIR)/Ganeti/HTools \
103         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104         $(COVERAGE_DIR) \
105         $(COVERAGE_PY_DIR) \
106         $(COVERAGE_HS_DIR) \
107         .hpc
108
109 BUILDTIME_DIRS = \
110         $(BUILDTIME_DIR_AUTOCREATE) \
111         doc/html
112
113 DIRCHECK_EXCLUDE = \
114         $(BUILDTIME_DIRS) \
115         ganeti-[0-9]*.[0-9]*.[0-9]* \
116         doc/html/_*
117
118 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119
120 # some helper vars
121 COVERAGE_DIR = doc/coverage
122 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 APIDOC_DIR = doc/api
125 APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127
128 MAINTAINERCLEANFILES = \
129         $(docpng) \
130         $(maninput) \
131         doc/install-quick.rst \
132         doc/news.rst \
133         doc/upgrade.rst \
134         vcs-version
135
136 maintainer-clean-local:
137         rm -rf $(BUILDTIME_DIRS)
138
139 CLEANFILES = \
140         $(addsuffix /*.py[co],$(DIRS)) \
141         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
143         $(all_dirfiles) \
144         $(PYTHON_BOOTSTRAP) \
145         epydoc.conf \
146         autotools/replace_vars.sed \
147         daemons/daemon-util \
148         daemons/ganeti-cleaner \
149         devel/upload \
150         $(BUILT_EXAMPLES) \
151         doc/examples/bash_completion \
152         lib/_generated_rpc.py \
153         $(man_MANS) \
154         $(manhtml) \
155         tools/kvm-ifup \
156         stamp-srclinks \
157         $(nodist_pkgpython_PYTHON) \
158         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159         $(HS_BUILT_TEST_HELPERS) \
160         .hpc/*.mix htools/*.tix \
161         doc/hs-lint.html
162
163 # BUILT_SOURCES should only be used as a dependency on phony
164 # targets. Otherwise it'll cause the target to rebuild every time.
165 BUILT_SOURCES = \
166   $(built_base_sources) \
167         $(BUILT_PYTHON_SOURCES) \
168         $(PYTHON_BOOTSTRAP)
169
170 built_base_sources = \
171         ganeti \
172         stamp-srclinks \
173         $(all_dirfiles)
174
175 built_python_base_sources = \
176         lib/_autoconf.py \
177         lib/_vcsversion.py
178
179 BUILT_PYTHON_SOURCES = \
180         $(built_python_base_sources) \
181         lib/_generated_rpc.py
182
183 # Generating the RPC wrappers depends on many things, so make sure it's built at
184 # the end of the built sources
185 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
186
187 # these are all built from the underlying %.in sources
188 BUILT_EXAMPLES = \
189         doc/examples/ganeti-kvm-poweroff.initd \
190         doc/examples/ganeti.cron \
191         doc/examples/ganeti.initd \
192         doc/examples/gnt-config-backup \
193         doc/examples/hooks/ipsec
194
195 nodist_pkgpython_PYTHON = \
196         $(BUILT_PYTHON_SOURCES)
197
198 noinst_PYTHON = \
199         lib/build/__init__.py \
200         lib/build/sphinx_ext.py \
201         lib/build/shell_example_lexer.py
202
203 pkgpython_PYTHON = \
204         lib/__init__.py \
205         lib/asyncnotifier.py \
206         lib/backend.py \
207         lib/bdev.py \
208         lib/bootstrap.py \
209         lib/cli.py \
210         lib/cmdlib.py \
211         lib/compat.py \
212         lib/config.py \
213         lib/constants.py \
214         lib/daemon.py \
215         lib/errors.py \
216         lib/ht.py \
217         lib/jqueue.py \
218         lib/jstore.py \
219         lib/locking.py \
220         lib/luxi.py \
221         lib/mcpu.py \
222         lib/netutils.py \
223         lib/objects.py \
224         lib/opcodes.py \
225         lib/ovf.py \
226         lib/qlang.py \
227         lib/query.py \
228         lib/rpc.py \
229         lib/rpc_defs.py \
230         lib/runtime.py \
231         lib/serializer.py \
232         lib/ssconf.py \
233         lib/ssh.py \
234         lib/storage.py \
235         lib/uidpool.py \
236         lib/workerpool.py
237
238 client_PYTHON = \
239         lib/client/__init__.py \
240         lib/client/gnt_backup.py \
241         lib/client/gnt_cluster.py \
242         lib/client/gnt_debug.py \
243         lib/client/gnt_group.py \
244         lib/client/gnt_instance.py \
245         lib/client/gnt_job.py \
246         lib/client/gnt_node.py \
247         lib/client/gnt_os.py
248
249 hypervisor_PYTHON = \
250         lib/hypervisor/__init__.py \
251         lib/hypervisor/hv_base.py \
252         lib/hypervisor/hv_chroot.py \
253         lib/hypervisor/hv_fake.py \
254         lib/hypervisor/hv_kvm.py \
255         lib/hypervisor/hv_lxc.py \
256         lib/hypervisor/hv_xen.py
257
258 rapi_PYTHON = \
259         lib/rapi/__init__.py \
260         lib/rapi/baserlib.py \
261         lib/rapi/client.py \
262         lib/rapi/client_utils.py \
263         lib/rapi/connector.py \
264         lib/rapi/rlib2.py \
265         lib/rapi/testutils.py
266
267 http_PYTHON = \
268         lib/http/__init__.py \
269         lib/http/auth.py \
270         lib/http/client.py \
271         lib/http/server.py
272
273 confd_PYTHON = \
274         lib/confd/__init__.py \
275         lib/confd/client.py \
276         lib/confd/querylib.py \
277         lib/confd/server.py
278
279 masterd_PYTHON = \
280         lib/masterd/__init__.py \
281         lib/masterd/instance.py
282
283 impexpd_PYTHON = \
284         lib/impexpd/__init__.py
285
286 watcher_PYTHON = \
287         lib/watcher/__init__.py \
288         lib/watcher/nodemaint.py \
289         lib/watcher/state.py
290
291 server_PYTHON = \
292         lib/server/__init__.py \
293         lib/server/confd.py \
294         lib/server/masterd.py \
295         lib/server/noded.py \
296         lib/server/rapi.py
297
298 pytools_PYTHON = \
299         lib/tools/__init__.py \
300         lib/tools/ensure_dirs.py
301
302 utils_PYTHON = \
303         lib/utils/__init__.py \
304         lib/utils/algo.py \
305         lib/utils/filelock.py \
306         lib/utils/hash.py \
307         lib/utils/io.py \
308         lib/utils/log.py \
309         lib/utils/mlock.py \
310         lib/utils/nodesetup.py \
311         lib/utils/process.py \
312         lib/utils/retry.py \
313         lib/utils/text.py \
314         lib/utils/wrapper.py \
315         lib/utils/x509.py
316
317 docrst = \
318         doc/admin.rst \
319         doc/design-2.0.rst \
320         doc/design-2.1.rst \
321         doc/design-2.2.rst \
322         doc/design-2.3.rst \
323         doc/design-htools-2.3.rst \
324         doc/design-2.4.rst \
325         doc/design-2.5.rst \
326         doc/design-2.6.rst \
327         doc/design-draft.rst \
328         doc/design-oob.rst \
329         doc/design-cpu-pinning.rst \
330         doc/design-query2.rst \
331         doc/design-x509-ca.rst \
332         doc/design-http-server.rst \
333         doc/design-impexp2.rst \
334         doc/design-lu-generated-jobs.rst \
335         doc/design-multi-reloc.rst \
336         doc/design-network.rst \
337         doc/design-chained-jobs.rst \
338         doc/design-ovf-support.rst \
339         doc/design-resource-model.rst \
340         doc/cluster-merge.rst \
341         doc/design-shared-storage.rst \
342         doc/design-node-state-cache.rst \
343         doc/design-virtual-clusters.rst \
344         doc/design-query-splitting.rst \
345         doc/devnotes.rst \
346         doc/glossary.rst \
347         doc/hooks.rst \
348         doc/iallocator.rst \
349         doc/index.rst \
350         doc/install-quick.rst \
351         doc/install.rst \
352         doc/locking.rst \
353         doc/move-instance.rst \
354         doc/news.rst \
355         doc/ovfconverter.rst \
356         doc/rapi.rst \
357         doc/security.rst \
358         doc/upgrade.rst \
359         doc/walkthrough.rst
360
361 HS_PROGS = htools/htools
362 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
363
364 HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
365 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
366 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
367
368 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
369 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
370 HEXTRA =
371 # internal extra flags (used for htools/test mainly)
372 HEXTRA_INT =
373 # exclude options for coverage reports
374 HPCEXCL = --exclude Main \
375         --exclude Ganeti.Constants \
376         --exclude Ganeti.THH \
377         --exclude Ganeti.HTools.QC \
378         --exclude Ganeti.HTools.QCHelper \
379         --exclude Ganeti.HTools.Version
380
381 HS_LIB_SRCS = \
382         htools/Ganeti/HTools/CLI.hs \
383         htools/Ganeti/HTools/Cluster.hs \
384         htools/Ganeti/HTools/Compat.hs \
385         htools/Ganeti/HTools/Container.hs \
386         htools/Ganeti/HTools/ExtLoader.hs \
387         htools/Ganeti/HTools/Group.hs \
388         htools/Ganeti/HTools/IAlloc.hs \
389         htools/Ganeti/HTools/Instance.hs \
390         htools/Ganeti/HTools/JSON.hs \
391         htools/Ganeti/HTools/Loader.hs \
392         htools/Ganeti/HTools/Luxi.hs \
393         htools/Ganeti/HTools/Node.hs \
394         htools/Ganeti/HTools/PeerMap.hs \
395         htools/Ganeti/HTools/QC.hs \
396         htools/Ganeti/HTools/QCHelper.hs \
397         htools/Ganeti/HTools/Rapi.hs \
398         htools/Ganeti/HTools/Simu.hs \
399         htools/Ganeti/HTools/Text.hs \
400         htools/Ganeti/HTools/Types.hs \
401         htools/Ganeti/HTools/Utils.hs \
402         htools/Ganeti/HTools/Program.hs \
403         htools/Ganeti/HTools/Program/Hail.hs \
404         htools/Ganeti/HTools/Program/Hbal.hs \
405         htools/Ganeti/HTools/Program/Hcheck.hs \
406         htools/Ganeti/HTools/Program/Hinfo.hs \
407         htools/Ganeti/HTools/Program/Hscan.hs \
408         htools/Ganeti/HTools/Program/Hspace.hs \
409         htools/Ganeti/BasicTypes.hs \
410         htools/Ganeti/Confd.hs \
411         htools/Ganeti/Confd/Server.hs \
412         htools/Ganeti/Config.hs \
413         htools/Ganeti/Daemon.hs \
414         htools/Ganeti/Hash.hs \
415         htools/Ganeti/Jobs.hs \
416         htools/Ganeti/Logging.hs \
417         htools/Ganeti/Luxi.hs \
418         htools/Ganeti/Objects.hs \
419         htools/Ganeti/OpCodes.hs \
420         htools/Ganeti/Runtime.hs \
421         htools/Ganeti/Ssconf.hs \
422         htools/Ganeti/THH.hs
423
424 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
425 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
426
427 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
428
429 # Note: we use here an order-only prerequisite, as the contents of
430 # _autoconf.py are not actually influencing the html build output: it
431 # has to exist in order for the sphinx module to be loaded
432 # successfully, but we certainly don't want the docs to be rebuilt if
433 # it changes
434 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
435         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
436         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
437         | $(BUILT_PYTHON_SOURCES)
438         @test -n "$(SPHINX)" || \
439             { echo 'sphinx-build' not found during configure; exit 1; }
440         @mkdir_p@ $(dir $@)
441         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
442             -d . \
443             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
444             -D release="$(PACKAGE_VERSION)" \
445             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
446         rm -f doc/html/.buildinfo doc/html/objects.inv
447         touch $@
448
449 doc/html: doc/html/index.html
450
451 doc/install-quick.rst: INSTALL
452 doc/news.rst: NEWS
453 doc/upgrade.rst: UPGRADE
454
455 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
456         set -e; \
457         { echo '.. This file is automatically updated at build time from $<.'; \
458           echo '.. Do not edit.'; \
459           echo; \
460           cat $<; \
461         } > $@
462
463 docdot = \
464         doc/arch-2.0.dot \
465         doc/design-2.1-lock-acquire.dot \
466         doc/design-2.1-lock-release.dot
467
468 docpng = $(patsubst %.dot,%.png,$(docdot))
469
470 # Things to build but not to install (add it to EXTRA_DIST if it should be
471 # distributed)
472 noinst_DATA = \
473         devel/upload \
474         doc/html \
475         $(BUILT_EXAMPLES) \
476         doc/examples/bash_completion \
477         $(manhtml)
478
479 gnt_scripts = \
480         scripts/gnt-backup \
481         scripts/gnt-cluster \
482         scripts/gnt-debug \
483         scripts/gnt-group \
484         scripts/gnt-instance \
485         scripts/gnt-job \
486         scripts/gnt-node \
487         scripts/gnt-os
488
489 PYTHON_BOOTSTRAP_SBIN = \
490         daemons/ganeti-masterd \
491         daemons/ganeti-noded \
492         daemons/ganeti-watcher \
493         daemons/ganeti-rapi \
494         $(gnt_scripts)
495
496 if PY_CONFD
497 PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
498 endif
499
500 PYTHON_BOOTSTRAP = \
501         $(PYTHON_BOOTSTRAP_SBIN) \
502         tools/ensure-dirs
503
504 qa_scripts = \
505         qa/__init__.py \
506         qa/ganeti-qa.py \
507         qa/qa_cluster.py \
508         qa/qa_config.py \
509         qa/qa_daemon.py \
510         qa/qa_env.py \
511         qa/qa_error.py \
512         qa/qa_group.py \
513         qa/qa_instance.py \
514         qa/qa_job.py \
515         qa/qa_node.py \
516         qa/qa_os.py \
517         qa/qa_rapi.py \
518         qa/qa_tags.py \
519         qa/qa_utils.py
520
521 bin_SCRIPTS =
522 if WANT_HTOOLS
523 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
524 install-exec-hook:
525         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
526 # FIXME: this is a hardcoded logic, instead of auto-resolving
527         $(LN_S) -f ../../../bin/htools \
528                    $(DESTDIR)$(iallocatorsdir)/hail
529         for role in $(HS_BIN_ROLES); do \
530                 $(LN_S) -f htools \
531                            $(DESTDIR)$(bindir)/$$role ; \
532         done
533 if HS_CONFD
534         mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
535 endif
536 endif
537
538 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
539         @if [ -z "$(HTOOLS)" ]; then \
540           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
541           exit 1; \
542         fi
543         @BINARY=$(@:htools/%=%); \
544         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
545           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
546           exit 1; \
547         fi
548         rm -f $(@:htools/%=%).tix
549         BINARY=$(@:htools/%=%); $(GHC) --make \
550           $(HFLAGS) \
551           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
552           -osuf $$BINARY.o -hisuf $$BINARY.hi \
553           $(HEXTRA) $(HEXTRA_INT) $@
554         @touch "$@"
555
556 # for the htools/test binary, we need to enable profiling/coverage
557 htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
558         -fno-warn-monomorphism-restriction -fno-warn-orphans \
559         -fno-warn-missing-methods -fno-warn-unused-imports
560
561 # we compile the hpc-htools binary with the program coverage
562 htools/hpc-htools: HEXTRA_INT=-fhpc
563
564 # test dependency
565 htools/offline-tests.sh: htools/hpc-htools
566
567 # rules for building profiling-enabled versions of the haskell
568 # programs: hs-prof does the full two-step build, whereas
569 # hs-prof-quick does only the final rebuild (hs-prof must have been
570 # run before)
571 .PHONY: hs-prof hs-prof-quick
572 hs-prof:
573         $(MAKE) clean
574         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
575         rm -f $(HS_ALL_PROGS)
576         $(MAKE) hs-prof-quick
577
578 hs-prof-quick:
579         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
580
581 dist_sbin_SCRIPTS = \
582         tools/ganeti-listrunner
583
584 nodist_sbin_SCRIPTS = \
585         $(PYTHON_BOOTSTRAP_SBIN) \
586         daemons/ganeti-cleaner
587
588 if HS_CONFD
589 nodist_sbin_SCRIPTS += htools/hconfd
590 endif
591
592 python_scripts = \
593         tools/burnin \
594         tools/cfgshell \
595         tools/cfgupgrade \
596         tools/cfgupgrade12 \
597         tools/cluster-merge \
598         tools/confd-client \
599         tools/fmtjson \
600         tools/lvmstrap \
601         tools/move-instance \
602         tools/ovfconverter \
603         tools/setup-ssh \
604         tools/sanitize-config
605
606 dist_tools_SCRIPTS = \
607         $(python_scripts) \
608         tools/kvm-console-wrapper \
609         tools/xm-console-wrapper \
610         tools/master-ip-setup
611
612 pkglib_python_scripts = \
613         daemons/import-export \
614         tools/check-cert-expired
615
616 nodist_pkglib_python_scripts = \
617         tools/ensure-dirs
618
619 myexeclib_SCRIPTS = \
620         daemons/daemon-util \
621         tools/kvm-ifup \
622         $(pkglib_python_scripts)
623
624 nodist_myexeclib_SCRIPTS = \
625         $(nodist_pkglib_python_scripts)
626
627 EXTRA_DIST = \
628         NEWS \
629         UPGRADE \
630         epydoc.conf.in \
631         pylintrc \
632         autotools/build-bash-completion \
633         autotools/build-rpc \
634         autotools/check-header \
635         autotools/check-python-code \
636         autotools/check-imports \
637         autotools/check-man-dashes \
638         autotools/check-man-warnings \
639         autotools/check-news \
640         autotools/check-tar \
641         autotools/check-version \
642         autotools/convert-constants \
643         autotools/docpp \
644         autotools/gen-coverage \
645         autotools/testrunner \
646         autotools/wrong-hardcoded-paths \
647         $(RUN_IN_TEMPDIR) \
648         daemons/daemon-util.in \
649         daemons/ganeti-cleaner.in \
650         $(pkglib_python_scripts) \
651         devel/upload.in \
652         tools/kvm-ifup.in \
653         $(docdot) \
654         $(docpng) \
655         $(docrst) \
656         doc/conf.py \
657         doc/html \
658         $(BUILT_EXAMPLES:%=%.in) \
659         doc/examples/ganeti.default \
660         doc/examples/ganeti.default-debug \
661         doc/examples/hooks/ethers \
662         doc/examples/gnt-debug/README \
663         doc/examples/gnt-debug/delay0.json \
664         doc/examples/gnt-debug/delay50.json \
665         test/lockperf.py \
666         test/testutils.py \
667         test/mocks.py \
668         $(dist_TESTS) \
669         $(TEST_FILES) \
670         man/footer.rst \
671         $(manrst) \
672         $(maninput) \
673         qa/qa-sample.json \
674         $(qa_scripts) \
675         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
676         $(HS_PROG_SRCS) \
677         htools/lint-hints.hs \
678         htools/cli-tests-defs.sh \
679         htools/offline-test.sh
680
681 man_MANS = \
682         man/ganeti.7 \
683         man/ganeti-cleaner.8 \
684         man/ganeti-confd.8 \
685         man/ganeti-listrunner.8 \
686         man/ganeti-masterd.8 \
687         man/ganeti-noded.8 \
688         man/ganeti-os-interface.7 \
689         man/ganeti-rapi.8 \
690         man/ganeti-watcher.8 \
691         man/gnt-backup.8 \
692         man/gnt-cluster.8 \
693         man/gnt-debug.8 \
694         man/gnt-group.8 \
695         man/gnt-instance.8 \
696         man/gnt-job.8 \
697         man/gnt-node.8 \
698         man/gnt-os.8 \
699         man/hail.1 \
700         man/hbal.1 \
701         man/hcheck.1 \
702         man/hinfo.1 \
703         man/hscan.1 \
704         man/hspace.1 \
705         man/htools.1
706
707 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
708 manhtml = $(patsubst %.rst,%.html,$(manrst))
709 mangen = $(patsubst %.rst,%.gen,$(manrst))
710 maninput = \
711         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
712         $(patsubst %.html,%.html.in,$(manhtml)) \
713         man/footer.man man/footer.html $(mangen)
714
715 TEST_FILES = \
716         test/data/bdev-drbd-8.0.txt \
717         test/data/bdev-drbd-8.3.txt \
718         test/data/bdev-drbd-disk.txt \
719         test/data/bdev-drbd-net-ip4.txt \
720         test/data/bdev-drbd-net-ip6.txt \
721         test/data/cert1.pem \
722         test/data/ip-addr-show-dummy0.txt \
723         test/data/ip-addr-show-lo-ipv4.txt \
724         test/data/ip-addr-show-lo-ipv6.txt \
725         test/data/ip-addr-show-lo-oneline-ipv4.txt \
726         test/data/ip-addr-show-lo-oneline-ipv6.txt \
727         test/data/ip-addr-show-lo-oneline.txt \
728         test/data/ip-addr-show-lo.txt \
729         test/data/proc_drbd8.txt \
730         test/data/proc_drbd80-emptyline.txt \
731         test/data/proc_drbd83.txt \
732         test/data/proc_drbd83_sync.txt \
733         test/data/proc_drbd83_sync_krnl2.6.39.txt \
734         test/data/kvm_1.0_help.txt \
735         test/data/kvm_0.15.90_help.txt \
736         test/data/kvm_0.12.5_help.txt \
737         test/data/kvm_0.9.1_help.txt \
738         test/data/sys_drbd_usermode_helper.txt \
739         test/data/htools/hail-alloc-drbd.json \
740         test/data/htools/hail-change-group.json \
741         test/data/htools/hail-invalid-reloc.json \
742         test/data/htools/hail-node-evac.json \
743         test/data/htools/hail-reloc-drbd.json \
744         test/data/htools/hbal-split-insts.data \
745         test/data/htools/common-suffix.data \
746         test/data/htools/invalid-node.data \
747         test/data/htools/missing-resources.data \
748         test/data/htools/rapi/groups.json \
749         test/data/htools/rapi/info.json \
750         test/data/htools/rapi/instances.json \
751         test/data/htools/rapi/nodes.json \
752         test/data/ovfdata/compr_disk.vmdk.gz \
753         test/data/ovfdata/config.ini \
754         test/data/ovfdata/corrupted_resources.ovf \
755         test/data/ovfdata/empty.ini \
756         test/data/ovfdata/empty.ovf \
757         test/data/ovfdata/ganeti.mf \
758         test/data/ovfdata/ganeti.ovf \
759         test/data/ovfdata/gzip_disk.ovf \
760         test/data/ovfdata/new_disk.vmdk \
761         test/data/ovfdata/no_disk.ini \
762         test/data/ovfdata/no_disk_in_ref.ovf \
763         test/data/ovfdata/no_os.ini \
764         test/data/ovfdata/no_ovf.ova \
765         test/data/ovfdata/ova.ova \
766         test/data/ovfdata/second_disk.vmdk \
767         test/data/ovfdata/rawdisk.raw \
768         test/data/ovfdata/unsafe_path.ini \
769         test/data/ovfdata/virtualbox.ovf \
770         test/data/ovfdata/wrong_extension.ovd \
771         test/data/ovfdata/wrong_config.ini \
772         test/data/ovfdata/wrong_manifest.mf \
773         test/data/ovfdata/wrong_manifest.ovf \
774         test/data/ovfdata/wrong_ova.ova \
775         test/data/ovfdata/wrong_xml.ovf \
776         test/data/ovfdata/other/rawdisk.raw \
777         test/data/vgreduce-removemissing-2.02.02.txt \
778         test/data/vgreduce-removemissing-2.02.66-fail.txt \
779         test/data/vgreduce-removemissing-2.02.66-ok.txt \
780         test/data/vgs-missing-pvs-2.02.02.txt \
781         test/data/vgs-missing-pvs-2.02.66.txt \
782         test/import-export_unittest-helper \
783         test/gnt-cli.test \
784         test/ganeti-cli.test \
785         test/htools-balancing.test \
786         test/htools-basic.test \
787         test/htools-dynutil.test \
788         test/htools-excl.test \
789         test/htools-hail.test \
790         test/htools-hspace.test \
791         test/htools-invalid.test \
792         test/htools-multi-group.test \
793         test/htools-no-backend.test \
794         test/htools-rapi.test \
795         test/htools-single-group.test \
796         test/htools-text-backend.test
797
798 python_tests = \
799         doc/examples/rapi_testutils.py \
800         test/ganeti.asyncnotifier_unittest.py \
801         test/ganeti.backend_unittest.py \
802         test/ganeti.bdev_unittest.py \
803         test/ganeti.cli_unittest.py \
804         test/ganeti.client.gnt_cluster_unittest.py \
805         test/ganeti.client.gnt_instance_unittest.py \
806         test/ganeti.daemon_unittest.py \
807         test/ganeti.cmdlib_unittest.py \
808         test/ganeti.compat_unittest.py \
809         test/ganeti.confd.client_unittest.py \
810         test/ganeti.config_unittest.py \
811         test/ganeti.constants_unittest.py \
812         test/ganeti.errors_unittest.py \
813         test/ganeti.hooks_unittest.py \
814         test/ganeti.ht_unittest.py \
815         test/ganeti.http_unittest.py \
816         test/ganeti.hypervisor_unittest.py \
817         test/ganeti.hypervisor.hv_chroot_unittest.py \
818         test/ganeti.hypervisor.hv_fake_unittest.py \
819         test/ganeti.hypervisor.hv_kvm_unittest.py \
820         test/ganeti.hypervisor.hv_lxc_unittest.py \
821         test/ganeti.hypervisor.hv_xen_unittest.py \
822         test/ganeti.impexpd_unittest.py \
823         test/ganeti.jqueue_unittest.py \
824         test/ganeti.locking_unittest.py \
825         test/ganeti.luxi_unittest.py \
826         test/ganeti.masterd.instance_unittest.py \
827         test/ganeti.mcpu_unittest.py \
828         test/ganeti.netutils_unittest.py \
829         test/ganeti.objects_unittest.py \
830         test/ganeti.opcodes_unittest.py \
831         test/ganeti.ovf_unittest.py \
832         test/ganeti.qlang_unittest.py \
833         test/ganeti.query_unittest.py \
834         test/ganeti.rapi.baserlib_unittest.py \
835         test/ganeti.rapi.client_unittest.py \
836         test/ganeti.rapi.resources_unittest.py \
837         test/ganeti.rapi.rlib2_unittest.py \
838         test/ganeti.rapi.testutils_unittest.py \
839         test/ganeti.rpc_unittest.py \
840         test/ganeti.runtime_unittest.py \
841         test/ganeti.serializer_unittest.py \
842         test/ganeti.ssh_unittest.py \
843         test/ganeti.storage_unittest.py \
844         test/ganeti.tools.ensure_dirs_unittest.py \
845         test/ganeti.uidpool_unittest.py \
846         test/ganeti.utils.algo_unittest.py \
847         test/ganeti.utils.filelock_unittest.py \
848         test/ganeti.utils.hash_unittest.py \
849         test/ganeti.utils.io_unittest.py \
850         test/ganeti.utils.log_unittest.py \
851         test/ganeti.utils.mlock_unittest.py \
852         test/ganeti.utils.nodesetup_unittest.py \
853         test/ganeti.utils.process_unittest.py \
854         test/ganeti.utils.retry_unittest.py \
855         test/ganeti.utils.text_unittest.py \
856         test/ganeti.utils.wrapper_unittest.py \
857         test/ganeti.utils.x509_unittest.py \
858         test/ganeti.utils_unittest.py \
859         test/ganeti.workerpool_unittest.py \
860         test/qa.qa_config_unittest.py \
861         test/cfgupgrade_unittest.py \
862         test/docs_unittest.py \
863         test/pycurl_reset_unittest.py \
864         test/tempfile_fork_unittest.py
865 if HAS_FAKEROOT
866 python_tests += test/ganeti.utils.io_unittest-runasroot.py
867 endif
868
869 haskell_tests = htools/test
870
871 dist_TESTS = \
872         test/check-cert-expired_unittest.bash \
873         test/daemon-util_unittest.bash \
874         test/ganeti-cleaner_unittest.bash \
875         test/import-export_unittest.bash \
876         test/cli-test.bash \
877         $(python_tests)
878
879 nodist_TESTS =
880 check_SCRIPTS =
881
882 if WANT_HTOOLSTESTS
883 nodist_TESTS += $(haskell_tests)
884 dist_TESTS += htools/offline-test.sh
885 check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
886 endif
887
888 TESTS = $(dist_TESTS) $(nodist_TESTS)
889
890 # Environment for all tests
891 PLAIN_TESTS_ENVIRONMENT = \
892         PYTHONPATH=. \
893         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
894         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
895         $(RUN_IN_TEMPDIR)
896
897 # Environment for tests run by automake
898 TESTS_ENVIRONMENT = \
899         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
900
901 all_python_code = \
902         $(dist_sbin_SCRIPTS) \
903         $(python_scripts) \
904         $(pkglib_python_scripts) \
905         $(nodist_pkglib_python_scripts) \
906         $(python_tests) \
907         $(pkgpython_PYTHON) \
908         $(client_PYTHON) \
909         $(hypervisor_PYTHON) \
910         $(rapi_PYTHON) \
911         $(server_PYTHON) \
912         $(pytools_PYTHON) \
913         $(http_PYTHON) \
914         $(confd_PYTHON) \
915         $(masterd_PYTHON) \
916         $(impexpd_PYTHON) \
917         $(utils_PYTHON) \
918         $(watcher_PYTHON) \
919         $(noinst_PYTHON) \
920         $(qa_scripts)
921
922 srclink_files = \
923         man/footer.rst \
924         test/check-cert-expired_unittest.bash \
925         test/daemon-util_unittest.bash \
926         test/ganeti-cleaner_unittest.bash \
927         test/import-export_unittest.bash \
928         test/cli-test.bash \
929         htools/offline-test.sh \
930         htools/cli-tests-defs.sh \
931         $(all_python_code) \
932         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
933
934 check_python_code = \
935         $(BUILD_BASH_COMPLETION) \
936         $(CHECK_IMPORTS) \
937         $(CHECK_HEADER) \
938         $(DOCPP) \
939         $(all_python_code)
940
941 lint_python_code = \
942         ganeti \
943         ganeti/http/server.py \
944         $(dist_sbin_SCRIPTS) \
945         $(python_scripts) \
946         $(pkglib_python_scripts) \
947         $(BUILD_BASH_COMPLETION) \
948         $(CHECK_IMPORTS) \
949         $(CHECK_HEADER) \
950         $(DOCPP) \
951         $(PYTHON_BOOTSTRAP)
952
953 standalone_python_modules = \
954         lib/rapi/client.py \
955         tools/ganeti-listrunner
956
957 pep8_python_code = \
958         ganeti \
959         ganeti/http/server.py \
960         $(dist_sbin_SCRIPTS) \
961         $(python_scripts) \
962         $(pkglib_python_scripts) \
963         $(BUILD_BASH_COMPLETION) \
964         $(CHECK_HEADER) \
965         $(DOCPP) \
966         $(PYTHON_BOOTSTRAP) \
967         qa
968
969 test/daemon-util_unittest.bash: daemons/daemon-util
970
971 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
972
973 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
974         sed -f $(REPLACE_VARS_SED) < $< > $@
975         chmod +x $@
976
977 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
978         sed -f $(REPLACE_VARS_SED) < $< > $@
979         chmod u+x $@
980
981 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
982         sed -f $(REPLACE_VARS_SED) < $< > $@
983         chmod +x $@
984
985 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
986         sed -f $(REPLACE_VARS_SED) < $< > $@
987
988 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
989         sed -f $(REPLACE_VARS_SED) < $< > $@
990
991 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
992         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
993         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
994
995 doc/%.png: doc/%.dot
996         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
997         $(DOT) -Tpng -o $@ $<
998
999 man/footer.man: man/footer.rst
1000         @test -n "$(PANDOC)" || \
1001           { echo 'pandoc' not found during configure; exit 1; }
1002         $(PANDOC) -f rst -t man -o $@ $<
1003
1004 man/footer.html: man/footer.rst
1005         @test -n "$(PANDOC)" || \
1006           { echo 'pandoc' not found during configure; exit 1; }
1007         $(PANDOC) -f rst -t html -o $@ $<
1008
1009 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1010         lib/build/shell_example_lexer.py \
1011         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1012         @echo "Checking $< for hardcoded paths..."
1013         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1014           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1015           exit 1; \
1016         fi
1017         set -e ; \
1018         trap 'echo auto-removing $@; rm $@' EXIT; \
1019         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1020         trap - EXIT
1021
1022 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1023         @test -n "$(PANDOC)" || \
1024           { echo 'pandoc' not found during configure; exit 1; }
1025         set -o pipefail ; \
1026         trap 'echo auto-removing $@; rm $@' EXIT; \
1027         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1028           sed -e 's/\\@/@/g' > $@; \
1029         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1030         $(CHECK_MAN_DASHES) $@; \
1031         trap - EXIT
1032
1033
1034 man/%.html.in: man/%.gen man/footer.html
1035         @test -n "$(PANDOC)" || \
1036           { echo 'pandoc' not found during configure; exit 1; }
1037         set -o pipefail ; \
1038         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1039           sed -e 's/\\@/@/g' > $@
1040
1041 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
1042         sed -f $(REPLACE_VARS_SED) < $< > $@
1043
1044 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
1045         sed -f $(REPLACE_VARS_SED) < $< > $@
1046
1047 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
1048         sed -f $(REPLACE_VARS_SED) < $< > $@
1049
1050 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
1051         sed -f $(REPLACE_VARS_SED) < $< > $@
1052
1053 epydoc.conf: epydoc.conf.in Makefile
1054         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1055
1056 vcs-version:
1057         if test -d .git; then \
1058           git describe > $@; \
1059         elif test ! -f $@ ; then \
1060           echo "Cannot auto-generate $@ file"; exit 1; \
1061         fi
1062
1063 .PHONY: clean-vcs-version
1064 clean-vcs-version:
1065         rm -f vcs-version
1066
1067 .PHONY: regen-vcs-version
1068 regen-vcs-version:
1069         set -e; \
1070         cd $(srcdir); \
1071         if test -d .git; then \
1072           $(MAKE) clean-vcs-version; \
1073           $(MAKE) vcs-version; \
1074         fi
1075
1076 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1077         set -e; \
1078         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1079         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1080
1081 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1082         lib/constants.py lib/_autoconf.py lib/luxi.py \
1083         $(CONVERT_CONSTANTS) \
1084         | lib/_vcsversion.py
1085         set -e; \
1086         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1087
1088 lib/_autoconf.py: Makefile | lib/.dir
1089         set -e; \
1090         { echo '# This file is automatically generated, do not edit!'; \
1091           echo '#'; \
1092           echo ''; \
1093           echo '"""Build-time configuration for Ganeti.'; \
1094           echo '';\
1095           echo 'This file is autogenerated by the build process.'; \
1096           echo 'For any changes you need to re-run ./configure (and'; \
1097           echo 'not edit by hand).'; \
1098           echo ''; \
1099           echo '"""'; \
1100           echo ''; \
1101           echo '# pylint: disable=C0301,C0324'; \
1102           echo '# because this is autogenerated, we do not want'; \
1103           echo '# style warnings' ; \
1104           echo ''; \
1105           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1106           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1107           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1108           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1109           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1110           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1111           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1112           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1113           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1114           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1115           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1116           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1117           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1118           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1119           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1120           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1121           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1122           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1123           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1124           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1125           echo "KVM_PATH = '$(KVM_PATH)'"; \
1126           echo "IP_PATH = '$(IP_PATH)'"; \
1127           echo "SOCAT_PATH = '$(SOCAT)'"; \
1128           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1129           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1130           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1131           echo "TOOLSDIR = '$(toolsdir)'"; \
1132           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1133           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1134           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1135           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1136           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1137           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1138           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1139           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1140           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1141           echo "RAPI_USER = '$(RAPI_USER)'"; \
1142           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1143           echo "CONFD_USER = '$(CONFD_USER)'"; \
1144           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1145           echo "NODED_USER = '$(NODED_USER)'"; \
1146           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1147           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1148           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1149           if [ "$(HTOOLS)" ]; then \
1150             echo "HTOOLS = True"; \
1151           else \
1152             echo "HTOOLS = False"; \
1153           fi; \
1154           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1155           echo "PY_CONFD = $(PY_CONFD)"; \
1156           echo "HS_CONFD = $(HS_CONFD)"; \
1157           echo "XEN_CMD = '$(XEN_CMD)'"; \
1158         } > $@
1159
1160 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1161         set -e; \
1162         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1163         { echo '# This file is automatically generated, do not edit!'; \
1164           echo '#'; \
1165           echo ''; \
1166           echo '"""Build-time VCS version number for Ganeti.'; \
1167           echo '';\
1168           echo 'This file is autogenerated by the build process.'; \
1169           echo 'For any changes you need to re-run ./configure (and'; \
1170           echo 'not edit by hand).'; \
1171           echo ''; \
1172           echo '"""'; \
1173           echo ''; \
1174           echo '# pylint: disable=C0301,C0324'; \
1175           echo '# because this is autogenerated, we do not want'; \
1176           echo '# style warnings' ; \
1177           echo ''; \
1178           echo "VCS_VERSION = '$$VCSVER'"; \
1179         } > $@
1180
1181 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1182         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1183
1184 $(REPLACE_VARS_SED): Makefile
1185         set -e; \
1186         { echo 's#@PREFIX@#$(prefix)#g'; \
1187           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1188           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1189           echo 's#@BINDIR@#$(bindir)#g'; \
1190           echo 's#@SBINDIR@#$(sbindir)#g'; \
1191           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1192           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1193           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1194           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1195           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1196           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1197           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1198           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1199           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1200           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1201           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1202           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1203           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1204           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1205           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1206           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1207           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1208           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1209           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1210         } > $@
1211
1212 # Using deferred evaluation
1213 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1214 daemons/ganeti-watcher: MODULE = ganeti.watcher
1215 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1216 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1217 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
1218
1219 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1220         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1221         set -e; \
1222         { echo '#!/usr/bin/python'; \
1223           echo '# This file is automatically generated, do not edit!'; \
1224           echo "# Edit $(MODULE) instead."; \
1225           echo; \
1226           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1227           echo; \
1228           echo '# pylint: disable=C0103'; \
1229           echo '# C0103: Invalid name'; \
1230           echo; \
1231           echo 'import sys'; \
1232           echo 'import $(MODULE) as main'; \
1233           echo; \
1234           echo '# Temporarily alias commands until bash completion'; \
1235           echo '# generator is changed'; \
1236           echo 'if hasattr(main, "commands"):'; \
1237           echo '  commands = main.commands # pylint: disable=E1101'; \
1238           echo 'if hasattr(main, "aliases"):'; \
1239           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1240           echo; \
1241           echo 'if __name__ == "__main__":'; \
1242           echo '  sys.exit(main.Main())'; \
1243         } > $@
1244         chmod u+x $@
1245
1246 $(HS_BUILT_TEST_HELPERS): Makefile
1247         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1248         set -e; \
1249         { echo '#!/bin/sh'; \
1250           echo '# This file is automatically generated, do not edit!'; \
1251           echo "# Edit Makefile.am instead."; \
1252           echo; \
1253           echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
1254         } > $@
1255         chmod u+x $@
1256
1257 # We need to create symlinks because "make distcheck" will not install Python
1258 # files when building.
1259 stamp-srclinks: Makefile | $(all_dirfiles)
1260         set -e; \
1261         for i in $(srclink_files); do \
1262                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1263                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1264                 fi; \
1265         done
1266         touch $@
1267
1268 .PHONY: ganeti
1269 ganeti:
1270         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1271
1272 .PHONY: check-dirs
1273 check-dirs: $(BUILT_SOURCES)
1274         @set -e; \
1275         find . -type d \( \( -name . \) -o \( \
1276                 -name .git -o \
1277                 -name autom4te.cache \
1278                 \) -prune -o -print \) | { \
1279                 error=; \
1280                 while read dir; do \
1281                         case "$$dir" in \
1282                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1283                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1284                         esac; \
1285                 done; \
1286                 for dir in $(DIRS); do \
1287                         if ! test -d "$$dir"; then \
1288                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1289                                 error=1; \
1290                         fi \
1291                 done; \
1292                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1293         }
1294
1295 .PHONY: check-local
1296 check-local: check-dirs $(BUILT_SOURCES)
1297         $(CHECK_PYTHON_CODE) $(check_python_code)
1298         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1299         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1300         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1301         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1302         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1303         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1304                 echo "Incorrect version in README, expected $$expver"; \
1305                 exit 1; \
1306         fi; \
1307         for file in doc/iallocator.rst doc/hooks.rst; do \
1308                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1309                         "Documents Ganeti version $$expver"; then \
1310                         echo "Incorrect version in $$file, expected $$expver"; \
1311                         exit 1; \
1312                 fi; \
1313         done
1314
1315 .PHONY: hs-check
1316 hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
1317         @rm -f test.tix
1318         ./htools/test
1319         HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1320
1321 # E111: indentation is not a multiple of four
1322 # E121: continuation line indentation is not a multiple of four
1323 #       (since our indent level is not 4)
1324 # E125: continuation line does not distinguish itself from next logical line
1325 #       (since our indent level is not 4)
1326 # E127: continuation line over-indented for visual indent
1327 #       (since our indent level is not 4)
1328 # E122,E123,E126,E128,E262,E272,E502,E711,: added temporarily to not
1329 #       modify stable code; do NOT merge these into master!
1330 # E261: at least two spaces before inline comment
1331 # E501: line too long (80 characters)
1332 PEP8_IGNORE = E111,E121,E122,E123,E125,E126,E127,E128,E261,E262,E272,E501,E502,E711
1333
1334 # For excluding pep8 expects filenames only, not whole paths
1335 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1336
1337 LINT_TARGETS = pylint pylint-qa
1338 if HAS_PEP8
1339 LINT_TARGETS += pep8
1340 endif
1341 if HAS_HLINT
1342 LINT_TARGETS += hlint
1343 endif
1344
1345 .PHONY: lint
1346 lint: $(LINT_TARGETS)
1347
1348 .PHONY: pylint
1349 pylint: $(BUILT_SOURCES)
1350         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1351         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1352
1353 .PHONY: pylint-qa
1354 pylint-qa: $(BUILT_SOURCES)
1355         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1356         cd $(top_srcdir)/qa && \
1357           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1358           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1359
1360 .PHONY: pep8
1361 pep8: $(BUILT_SOURCES)
1362         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1363         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1364                 --repeat $(pep8_python_code)
1365
1366 .PHONY: hlint
1367 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1368         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1369         if tty -s; then C="-c"; else C=""; fi; \
1370         $(HLINT) --report=doc/hs-lint.html --cross $$C \
1371           --ignore "Use first" \
1372           --ignore "Use comparing" \
1373           --ignore "Use on" \
1374           --ignore "Reduce duplication" \
1375           --hint htools/lint-hints \
1376           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1377
1378 # a dist hook rule for updating the vcs-version file; this is
1379 # hardcoded due to where it needs to build the file...
1380 dist-hook:
1381         $(MAKE) regen-vcs-version
1382         rm -f $(top_distdir)/vcs-version
1383         cp -p $(srcdir)/vcs-version $(top_distdir)
1384
1385 # a distcheck hook rule for catching revision control directories
1386 distcheck-hook:
1387         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1388                 echo "Found revision control files in final archive." 1>&2; \
1389                 exit 1; \
1390         fi
1391         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1392                 echo "Found Python byte code in final archive." 1>&2; \
1393                 exit 1; \
1394         fi
1395         if find $(top_distdir) -name '*~' | grep .; then \
1396                 echo "Found backup files in final archive." 1>&2; \
1397                 exit 1; \
1398         fi
1399 # Empty files or directories should not be distributed. They can cause
1400 # unnecessary warnings for packagers. Directories used by automake during
1401 # distcheck must be excluded.
1402         if find $(top_distdir) -empty -and -not \( \
1403                         -path $(top_distdir)/_build -or \
1404                         -path $(top_distdir)/_inst \) | grep .; then \
1405                 echo "Found empty files or directories in final archive." 1>&2; \
1406                 exit 1; \
1407         fi
1408         if test -n "$(BUILD_RELEASE)" && \
1409            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1410                 echo "Found unreleased version in NEWS." >&2; \
1411                 exit 1; \
1412         fi
1413
1414 # When building a release, stricter checks should be used
1415 distcheck-release dist-release: export BUILD_RELEASE = 1
1416 distcheck-release: distcheck
1417
1418 distrebuildcheck: dist
1419         set -e; \
1420         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1421         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1422         cd $$builddir; \
1423         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1424         cd $(distdir); \
1425         ./configure; \
1426         $(MAKE) maintainer-clean; \
1427         cp $(abs_srcdir)/vcs-version .; \
1428         ./configure; \
1429         $(MAKE) $(AM_MAKEFLAGS)
1430
1431 dist-release: dist
1432         set -e; \
1433         for i in $(DIST_ARCHIVES); do \
1434                 echo -n "Checking $$i ... "; \
1435                 autotools/check-tar < $$i; \
1436                 echo OK; \
1437         done
1438
1439 install-exec-local:
1440         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1441           "$(DESTDIR)${localstatedir}/log/ganeti" \
1442           "$(DESTDIR)${localstatedir}/run/ganeti"
1443
1444 # To avoid conflicts between directory names and other targets, a file inside
1445 # the directory is used to ensure its existence.
1446 %.dir:
1447         @mkdir_p@ $* && touch $@
1448
1449 .PHONY: apidoc
1450 if WANT_HTOOLSAPIDOC
1451 apidoc: py-apidoc hs-apidoc
1452 else
1453 apidoc: py-apidoc
1454 endif
1455
1456 .PHONY: py-apidoc
1457 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1458         $(RUN_IN_TEMPDIR) epydoc -v \
1459                 --conf $(CURDIR)/epydoc.conf \
1460                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1461
1462 .PHONY: hs-apidoc
1463 hs-apidoc: $(HS_BUILT_SRCS)
1464         @test -n "$(HSCOLOUR)" || \
1465             { echo 'HsColour' not found during configure; exit 1; }
1466         @test -n "$(HADDOCK)" || \
1467             { echo 'haddock' not found during configure; exit 1; }
1468         rm -rf $(APIDOC_HS_DIR)/*
1469         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1470         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1471         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1472         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1473         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1474         set -e ; \
1475         cd htools; \
1476         if [ "$(HTOOLS_NOCURL)" ]; \
1477         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1478         else OPTGHC=""; \
1479         fi; \
1480         if [ "$(HTOOLS_PARALLEL3)" ]; \
1481         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1482         fi; \
1483         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1484         for file in $$RELSRCS; do \
1485                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1486                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1487         done ; \
1488         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1489                 -t ganeti-htools -p haddock-prologue \
1490                 --source-module="%{MODULE/.//}.html" \
1491                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1492                 $$OPTGHC \
1493                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1494
1495 .PHONY: TAGS
1496 TAGS: $(BUILT_SOURCES)
1497         rm -f TAGS
1498         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1499           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1500           -path './qa/*.py' | \
1501           etags -l python -
1502
1503 .PHONY: coverage
1504 if WANT_HTOOLS
1505 coverage: py-coverage hs-coverage
1506 else
1507 coverage: py-coverage
1508 endif
1509
1510 .PHONY: py-coverage
1511 py-coverage: $(BUILT_SOURCES) $(python_tests)
1512         set -e; \
1513         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1514         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1515         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1516         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1517         $(python_tests)
1518
1519 .PHONY: hs-coverage
1520 hs-coverage: $(haskell_tests) htools/hpc-htools
1521         rm -f *.tix
1522         $(MAKE) hs-check
1523         @mkdir_p@ $(COVERAGE_HS_DIR)
1524         hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1525         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1526         hpc report coverage-htools.tix
1527         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1528
1529 # Special "kind-of-QA" target for htools, needs special setup (all
1530 # tools compiled with -fhpc)
1531 .PHONY: live-test
1532 live-test: all
1533         set -e ; \
1534         cd htools; \
1535         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1536         rm -f *.tix *.mix; \
1537         ./live-test.sh; \
1538         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1539           --output=live-test.tix ; \
1540         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1541         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1542                 --srcdir=.. $(HPCEXCL) ; \
1543         hpc report --srcdir=.. live-test $(HPCEXCL)
1544
1545 commit-check: distcheck lint apidoc
1546
1547 .PHONY: gitignore-check
1548 gitignore-check:
1549         @if [ -n "`git status --short`" ]; then \
1550           echo "Git status is not clean!" 1>&2 ; \
1551           git status --short; \
1552           exit 1; \
1553         fi
1554
1555 -include ./Makefile.local
1556
1557 # vim: set noet :